﻿function Init() {
    document.body.innerHTML = "";
};



var codeEditor;
var codeChangeDummyDiv;
function LoadCodeEditor(code) {
    Init();
    var editorDiv = document.body.appendChild(document.createElement("div"));
    editorDiv.id = "codeEditor";
    editorDiv.style.top = 0;
    editorDiv.style.bottom = 0;
    editorDiv.style.left = 0;
    editorDiv.style.right = 0;
    editorDiv.style.position = "absolute";
    editorDiv.appendChild(document.createTextNode(code));

    codeChangeDummyDiv = document.body.appendChild(document.createElement("div"));
    codeChangeDummyDiv.id = "CodeEditorCodeChangedDiv";

    ace.require("ace/ext/language_tools");
    codeEditor = ace.edit("codeEditor");
    var session = codeEditor.getSession();
    session.setMode("ace/mode/cal");
    session.setUseSoftTabs(true);
    session.setTabSize(2);
    codeEditor.setOptions({
        enableBasicAutocompletion: true,
        enableLiveAutocompletion: true
    });
    session.on('change', codeEditorDocumentChange);

}

function codeEditorDocumentChange(obj) {
    /*if (!debug)
        Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("CodeChanged", null);
    else {
        codeChangeDummyDiv.click();
    }*/
}


function GetCode() {
    if (!debug)
        Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("CodeGetReceived", [codeEditor.getValue()]);
    return codeEditor.getValue();
}


var debug = false;
function SetDebug(value)
{
    debug = value;
}

var statusBar;
var logo;
function Preview(xmlText) {
    Init();
    //try
    //{
        var page = document.body.appendChild(document.createElement("div"));
    
        // Sections
        var topSection = page.appendChild(document.createElement("header"));
        topSection.className = "topPart";
        var reportHeader = topSection.appendChild(document.createElement("div"));
        reportHeader.className = "globalSection";
        reportHeader.className += " reportHeader";
        reportHeader.id = "ReportHeader";
        var reportBody = topSection.appendChild(document.createElement("div"));
        reportBody.className = "globalSection";
        reportBody.id = "ReportBody";

        var bottomSection = page.appendChild(document.createElement("footer"));
        bottomSection.className = "bottomPart";
        var reportFooter = bottomSection.appendChild(document.createElement("div"));
        reportFooter.className = "globalSection";
        reportHeader.className += " reportFooter";
        reportFooter.id = "ReportFooter";

        statusBar = bottomSection.appendChild(document.createElement("div"));
        statusBar.className = "statusBar";
        statusBar.style.visibility = "hidden";

        logo = page.appendChild(document.createElement("img"));
        if (!debug)
            logo.src = Microsoft.Dynamics.NAV.GetImageResource("Logo-white.png");
        else
            logo.src = "Image/Logo-white.png";
        logo.className = "logo";

        var parser = new DOMParser();
        var xmlDoc = parser.parseFromString(xmlText, "text/xml");
        var layout = xmlDoc.getElementsByTagName("Layout")[0];
        var report = xmlDoc.getElementsByTagName("Report")[0];

        var uom = xmlDoc.getElementsByTagName("Report")[0].getAttribute("Unit_of_Measure");

        var areaWidth = parseFloat(report.getAttribute("Page_Width"))
            - parseFloat(report.getAttribute("Left_Margin")) - parseFloat(report.getAttribute("Right_Margin"));
        var BorderWidth = 0.2; //mm
        if (uom == "in")
            BorderWidth /= 2.54;
        areaWidth -= BorderWidth;

        page.style.width = areaWidth + uom;
        page.className = "page";
        reportBody.style.width = areaWidth + uom;
        reportHeader.style.width = areaWidth + uom;
        reportFooter.style.width = areaWidth + uom;

        var datasetItems = xmlDoc.getElementsByTagName("DataSetItem");
        var layoutItems = layout.getElementsByTagName("LayoutItem");
        var layoutItemEntryNo = 0;
        for (var i = 0; i < layoutItems.length; i++) {
            layoutItemEntryNo += 10000;
            layoutItems[i].setAttribute("Entry_No_", layoutItemEntryNo);
        }
        dataItems = [];
        for (var i = 0; i < datasetItems.length; i++)
        {
            var di = datasetItems[i];

            if (di.getAttribute("Type") == "Table") {
                var dataItem = {
                    name: di.getAttribute("Name"),
                    indentation: di.getAttribute("Indentation"),
                    sections: []
                };

                for (var j = 0; j < layoutItems.length; j++) {
                    var sect = layoutItems[j];
                    if (sect.getAttribute("Type") == "Section") {
                        if (sect.getAttribute("Source") == dataItem.name) {
                            var section = {
                                sectionType: sect.getAttribute("Section_Type"),
                                sectionID: sect.getAttribute("Entry_No_"),
                            }
                            dataItem.sections.push(section);
                        }
                    }
                }

                dataItems.push(dataItem);
            }
        }
        
        BuildTablixSections(dataItems, reportBody, null, 0);


        var i;
        var layoutItem = null;
        var section = null;
        var currRect = null;
        var headerHeight = { value: 0 };
        var footerHeight = { value: 0 };
        var groupHeight = { value: 0 };
        BuildElements(layoutItem, layoutItems, reportHeader, reportBody, reportFooter, headerHeight, footerHeight, uom, section, currRect, areaWidth, groupHeight);
    //}
    //catch(e)
    //{
    //    alert(e.message);
    //}
};


function BuildTablixSections(dataItems, reportBody, parentDataitem, level)
{
    for (var i = 0; i < dataItems.length; i++)
    {
        var dataitem = dataItems[i];
        if (dataitem.indentation == level)
        {
            var check = false;
            var child = false;
            if (parentDataitem == null)
                child = true;
            else
                for (var j = 0; j < dataItems.length; j++)
                {
                    var di = dataItems[j];
                    if (check)
                    {
                        if (di.indentation == parentDataitem.indentation) // Passed the parent level
                            break;

                        if (di.name == dataitem.name)
                        {
                            child = true;
                            break;
                        }
                    }
                    if (di.name == parentDataitem.name)
                        check = true;
                }

            if (child)
            {
                // Add header and body sections
                for (var k = 0; k < dataitem.sections.length; k++)
                {
                    var section = dataitem.sections[k];
                    if (section.sectionType == "Header")
                    {
                        AddTablixRow(reportBody, section);
                    }
                }
                for (var k = 0; k < dataitem.sections.length; k++)
                {
                    var section = dataitem.sections[k];
                    if (section.sectionType == "GroupHeader")
                    {
                        AddTablixRow(reportBody, section);
                    }
                }
                for (var k = 0; k < dataitem.sections.length; k++)
                {
                    var section = dataitem.sections[k];
                    if (section.sectionType == "Body")
                    {
                        AddTablixRow(reportBody, section);
                    }
                }

                BuildTablixSections(dataItems, reportBody, dataitem, level + 1);

                // Add footer sections
                for (var k = 0; k < dataitem.sections.length; k++)
                {
                    var section = dataitem.sections[k];
                    if (section.sectionType == "GroupFooter")
                    {
                        AddTablixRow(reportBody, section);
                    }
                }
                for (var k = 0; k < dataitem.sections.length; k++)
                {
                    var section = dataitem.sections[k];
                    if (section.sectionType == "Footer")
                    {
                        AddTablixRow(reportBody, section);
                    }
                }
            }
        }
    }
}

function AddTablixRow(reportBody, section)
{
    var rect = reportBody.appendChild(document.createElement("div"));
    rect.MetaSectionID = section.sectionID;
}


function BuildElements(layoutItem, layoutItems, reportHeader, reportBody, reportFooter, headerHeight, footerHeight, uom, section, currRect, areaWidth, groupHeight) {
    var ExpressionConstant = "<Expression>";
    var parentIndent = -1;
    // Coordinates of relative elements
    var rectHeight = 0;
    var rectWidth = 0;
    var rectLeft = 0;
    var rectRight = 0;
    var rectTop = 0;
    var rectCenter = 0;
    var centeredItems = [];
    var centeredItemWidths = [];
    var rightItems = [];
    var rightItemWidths = [];
    var prevHeight = 0;
    var prevTop = 0;
    var prevType = "";
    var prevSectionType = "";
    var prevHFSectionType = "";
    var previousCommonItem = null;

    var layout = "Columns";
    var innerRect = null;
    if (layoutItem != null)
    {
        parentIndent = parseInt(layoutItem.getAttribute("Indentation"));
        layout = layoutItem.getAttribute("Section_Layout");
        
        if (layout == "")
            layout = "Columns";

        rectRight = parseFloat(layoutItem.getAttribute("Width"));
        rectCenter = rectRight / 2;
    }
    else
    {
        rectRight = areaWidth;
        rectCenter = rectRight / 2;
    }

    while (true) {
        if (layoutItem == null) // First
            layoutItem = layoutItems[0];
        else {
            layoutItem = layoutItem.nextElementSibling;
        }

        if (layoutItem == null)
            break;


        var indent = parseInt(layoutItem.getAttribute("Indentation"));
        if (indent > parentIndent + 1) // Go back to next section/group
        {
            layoutItem = layoutItem.previousElementSibling;

            var innerGroupHeight = { value: 0 };

            layoutItem = BuildElements(layoutItem, layoutItems, reportHeader, reportBody, reportFooter, headerHeight, footerHeight, uom, section, innerRect, areaWidth, innerGroupHeight);

            if (groupHeight.value < innerGroupHeight.value + prevTop)
                groupHeight.value = innerGroupHeight.value + prevTop;

            if (groupHeight.value < prevTop + prevHeight)
                groupHeight.value = prevTop + prevHeight;

            innerRect.style.height = innerGroupHeight.value + uom;
            if (prevType == "Section")
                if (section.reportHeader)
                    reportHeader.style.height = groupHeight.value + uom;
                else if (section.reportFooter)
                    reportFooter.style.height = groupHeight.value + uom;

            if (layoutItem == null)
                break;
            else
                continue;
        }
        if (indent <= parentIndent) // Go back to previous section/group
        {
            layoutItem = layoutItem.previousElementSibling;
            break;
        }


        var type = layoutItem.getAttribute("Type");
        var concat = layoutItem.getAttribute("Concat") == "Yes";
        var sectionType = layoutItem.getAttribute("Section_Type");
        var source = layoutItem.getAttribute("Source");
        if (source.length > 0 && source[0] == "=")
            source = source.substring(1);
        var borderColor = layoutItem.getAttribute("Border_Color").replace(" ", "");
        var borderStyle = layoutItem.getAttribute("Border_Style").replace(" ", "");
        var borderWidthLeft = layoutItem.getAttribute("BorderWidth_Left");
        var borderWidthRight = layoutItem.getAttribute("BorderWidth_Right");
        var borderWidthTop = layoutItem.getAttribute("BorderWidth_Top");
        var borderWidthBottom = layoutItem.getAttribute("BorderWidth_Bottom");
        var itemFloat = layoutItem.getAttribute("Float");
        var width = parseFloat(layoutItem.getAttribute("Width"));
        //if (width == 0)
        //    width = defaultWidth;
        var height = parseFloat(layoutItem.getAttribute("Height"));
        //if (height == 0)
        //    height = defaultHeight;
        var left = parseFloat(layoutItem.getAttribute("Left"));
        var top = parseFloat(layoutItem.getAttribute("Top"));
        var defaultFlow = (left == 0) && (top == 0);
        var commonItem = null;
        var globalSection = false;
        if (type == "Section" && layoutItem.getAttribute("Source") == "")
            globalSection = true;
        else {
            if ((prevHFSectionType != sectionType) // Reset global rectangle, when moving to Report Footer
                && (sectionType == "Report Footer")) {
                rectHeight = 0;
                rectWidth = 0;
                rectLeft = 0;
                //rectRight = 0;
                rectTop = 0;
                //rectCenter = 0;

                rectRight = areaWidth;
                rectCenter = rectRight / 2;
                rightItems = [];
                centeredItems = [];
                rightItemWidths = [];
                centeredItemWidths = [];
            }

            if (defaultFlow) {
                if (layout == "Rows") {
                    top = rectTop;
                    rectTop += height;

                    //if (itemFloat == "Right") {
                    //    left = rectRight - width;
                    //}
                }
                else // Columns
                {
                    if (itemFloat == "Left") {
                        left = rectLeft;
                        rectLeft += width;
                    }
                    //else if (itemFloat == "Right") {
                    //    left = rectRight - width;
                    //    rectRight -= width;
                    //}
                    // Center and Right is handled below
                }
            }
        }

        if (type == "Section") {
            if (!globalSection) {
                groupHeight.value = 0;

                section = { reportHeader: false, reportFooter: false };
                if (sectionType == "Report Header") {
                    section.reportHeader = true;
                    innerRect = reportHeader.appendChild(document.createElement("div"));

                    innerRect.style.height = height + uom;
                    innerRect.style.width = width + uom;
                    innerRect.style.top = top + uom;
                    innerRect.style.left = left + uom;
                    innerRect.style.position = "absolute";
                }
                else if (sectionType == "Report Footer") {
                    section.reportFooter = true;
                    innerRect = reportFooter.appendChild(document.createElement("div"));

                    innerRect.style.height = height + uom;
                    innerRect.style.width = width + uom;
                    innerRect.style.top = top + uom;
                    innerRect.style.left = left + uom;
                    innerRect.style.position = "absolute";
                }
                else {
                    innerRect = null;
                    for (var j = 0; j < reportBody.children.length; j++) {
                        var element = reportBody.children[j];
                        if (element.MetaSectionID == layoutItem.getAttribute("Entry_No_")) {
                            innerRect = element;
                            break;
                        }
                    }
                    if (innerRect == null)
                        innerRect = reportBody.appendChild(document.createElement("div"));
                    innerRect.style.height = height + uom;
                    innerRect.style.width = width + uom;
                    innerRect.sectionType = "Body";
                }
                innerRect.className = "section";
                commonItem = innerRect;
            }
            else // Global Sections
            {
                if (layoutItem.getAttribute("Section_Type") == "Report Header")
                    commonItem = reportHeader;
                else if (layoutItem.getAttribute("Section_Type") == "Report Footer")
                    commonItem = reportFooter;
                else if (layoutItem.getAttribute("Section_Type") == "Body")
                    commonItem = reportBody;
            }
        }
        else // Not Section
        {
            /*if (section.reportHeader || section.reportFooter)
                if (section.reportHeader)
                {
                    if (top + height > headerHeight.value) {
                        headerHeight.value = top + height
                        if (reportHeader.style.height < headerHeight.value + uom)
                            reportHeader.style.height = headerHeight.value + uom;
                    }
                }
                else // Footer
                {
                    if (top + height > footerHeight.value) {
                        footerHeight.value = top + height;
                        if (reportFooter.style.height < footerHeight.value + uom)
                            reportFooter.style.height = footerHeight.value + uom;
                    }
                }*/

            if (type == "Group") {
                var rect = currRect.appendChild(document.createElement("span"));
                rect.style.height = height + uom;
                rect.style.width = width + uom;
                rect.style.top = top + uom;
                rect.style.left = left + uom;
                rect.className = "group";

                innerRect = rect;
                commonItem = rect;
            }
            else if (type == "Textbox") {
                if (source != "") {
                    var textbox = currRect.appendChild(document.createElement("span"));
                    textbox.style.height = height + uom;
                    textbox.style.width = width + uom;
                    textbox.style.top = top + uom;
                    textbox.style.left = left + uom;
                    var textNode = document.createElement("span");
                    textNode.appendChild(document.createTextNode(source));
                    textbox.appendChild(textNode);

                    var paddingLeft = parseInt(layoutItem.getAttribute("Padding_Left"));
                    var paddingRight = parseInt(layoutItem.getAttribute("Padding_Right"));
                    var paddingTop = parseInt(layoutItem.getAttribute("Padding_Top"));
                    var paddingBottom = parseInt(layoutItem.getAttribute("Padding_Bottom"));

                    textbox.style.paddingLeft = paddingLeft + "pt";
                    textbox.style.paddingRight = paddingRight + "pt";
                    textbox.style.paddingTop = paddingTop + "pt";
                    textbox.style.paddingBottom = paddingBottom + "pt";

                    var textAlign = layoutItem.getAttribute("Text_Align").replace(" ", "");
                    var verticalAlign = layoutItem.getAttribute("Vertical_Align").replace(" ", "");
                    //textbox.style.textAlign = textAlign;

                    if (verticalAlign != "")
                        textNode.style.position = "absolute";
                    switch (verticalAlign) {
                        case "Top":
                            textNode.style.top = 0;
                            break;
                        case "Bottom":
                            textNode.style.bottom = 0;
                            break;
                        case "Middle":
                            textbox.style.lineHeight = height + uom;
                            break;
                        default:
                            break;
                    }

                    var fontName = layoutItem.getAttribute("Font_Name").replace(" ", "");
                    if (fontName == ExpressionConstant)
                        fontName = "";
                    var fontStyle = layoutItem.getAttribute("Font_Style").replace(" ", "");
                    if (fontStyle == ExpressionConstant)
                        fontStyle = "";
                    var fontSize = layoutItem.getAttribute("Font_Size");
                    if (fontSize == "0")
                        fontSize = "0";
                    var fontWeight = layoutItem.getAttribute("Font_Weight").replace(" ", "");
                    if (fontWeight == ExpressionConstant)
                        fontWeight = "";
                    var fontTextDecoration = layoutItem.getAttribute("Font_Text_Decoration").replace(" ", "");
                    if (fontTextDecoration == ExpressionConstant)
                        fontTextDecoration = "";
                    var fontColor = layoutItem.getAttribute("Font_Color").replace(" ", "");
                    if (fontColor == ExpressionConstant)
                        fontColor = "";

                    if (fontName != "")
                        textbox.style.fontFamily = fontName;
                    if (fontStyle != "")
                        textbox.style.fontStyle = fontStyle;
                    if (fontSize != "0")
                        textbox.style.fontSize = fontSize + "pt";
                    if (fontWeight != "") {
                        switch (fontWeight) {
                            case "Normal":
                                break;
                            case "Thin":
                                fontWeight = "200";
                                break;
                            case "ExtraLight":
                                fontWeight = "300";
                                break;
                            case "Light":
                                fontWeight = "400";
                                break;
                            case "Medium":
                                fontWeight = "500";
                                break;
                            case "SemiBold":
                                fontWeight = "600";
                                break;
                            case "Bold":
                                fontWeight = "700";
                                break;
                            case "ExtraBold":
                                fontWeight = "800";
                                break;
                            case "Heavy":
                                fontWeight = "900";
                                break;
                        }
                        textbox.style.fontWeight = fontWeight;
                    }
                    if (fontTextDecoration != "") {
                        if (fontTextDecoration == "LineThrough")
                            fontTextDecoration = "line-through";
                        textbox.style.textDecoration = fontTextDecoration;
                    }
                    if (fontColor != "")
                        textbox.style.color = fontColor;

                    if (concat) {
                        if (previousCommonItem != null) {
                            var currValue = $(textbox).text();
                            if (currValue.indexOf("=") == 0)
                                currValue = currValue.substring(1);
                            $(previousCommonItem).text($(previousCommonItem).text() + " & " + currValue);
                            currRect.removeChild(textbox);
                        }
                    }

                    commonItem = textbox;
                    commonItem.className += " commonItem";
                }
            }
            else if (type == "Picture") {
                var image = currRect.appendChild(document.createElement("img"));
                image.style.height = height + uom;
                image.style.width = width + uom;
                image.style.top = top + uom;
                image.style.left = left + uom;
                image.alt = source;

                image.className = "image";
                commonItem = image;
                commonItem.className += " commonItem";
            }
            else if (type == "Line") {
                var endLeft = layoutItem.getAttribute("End_Left");
                var endTop = layoutItem.getAttribute("End_Top");

                var line = currRect.appendChild(document.createElement("canvas"));
                line.style.height = Math.abs(endTop - top) + uom;
                line.style.width = Math.abs(endLeft - left) + uom;

                if ((endTop - top) >= 0)
                    line.style.top = top + uom;
                else
                    line.style.top = endTop + uom;

                if ((endLeft - left) >= 0)
                    line.style.left = left + uom;
                else
                    line.style.left = endLeft + uom;

                var startLeftPx = 0, endLeftPx = 0, startTopPx = 0, endTopPx = 0;

                if ((endTop - top) >= 0)
                    endTopPx = line.height;
                else
                    startTopPx = line.height;

                if ((endLeft - left) >= 0)
                    endLeftPx = line.width;
                else
                    startLeftPx = line.width;

                var ctx = line.getContext("2d");
                ctx.moveTo(startLeftPx, startTopPx);
                ctx.lineTo(endLeftPx, endTopPx);
                ctx.strokeStyle = borderColor;
                ctx.stroke();

                commonItem = line;
                commonItem.className += " commonItem";
            }
            else if (type == "Rectangle") {
                var rect = currRect.appendChild(document.createElement("span"));
                rect.style.height = height + uom;
                rect.style.width = width + uom;
                rect.style.top = top + uom;
                rect.style.left = left + uom;
                rect.className = "group";

                innerRect = rect;
                commonItem = rect;
                commonItem.className += " commonItem";
            }

        }

        // Center and Right Float
        var centerFloat = (itemFloat == "Center");
        var rightFloat = (itemFloat == "Right");
        if ((defaultFlow) && (centerFloat || rightFloat)) {
            if (centerFloat) {
                centeredItemWidths.push(width);
                centeredItems.push(commonItem);
            }
            else if (rightFloat) {
                rightItemWidths.push(width);
                rightItems.push(commonItem);
            }

            var fullWidth = 0;
            if (centerFloat)
                for (var k = 0; k < centeredItemWidths.length; k++) {
                    var itemWidth = centeredItemWidths[k];
                    fullWidth += itemWidth;
                }
            else if (rightFloat)
                for (var k = 0; k < rightItemWidths.length; k++) {
                    var itemWidth = rightItemWidths[k];
                    fullWidth += itemWidth;
                }

            var startLeft = 0;
            if (centerFloat)
                startLeft = rectCenter - fullWidth / 2;
            else if (rightFloat)
                startLeft = rectRight - fullWidth;

            if (startLeft < 0)
                startLeft = 0;

            for (var i = 0; (centerFloat && i < centeredItemWidths.length)
                || (rightFloat && i < rightItemWidths.length) ; i++) {
                var itemWidth = 0;
                var item = null;
                if (centerFloat) {
                    itemWidth = centeredItemWidths[i];
                    item = centeredItems[i];
                }
                else if (rightFloat) {
                    itemWidth = rightItemWidths[i];
                    item = rightItems[i];
                }

                item.style.left = startLeft + uom;

                if (layout == "Columns")
                    startLeft += itemWidth;
            }
        }


        if (commonItem != null) {
            commonItem.id = layoutItem.getAttribute("Entry_No_");

            if (borderStyle != "") {
                if (borderColor != "")
                    commonItem.style.borderColor = borderColor;

                if (borderWidthLeft != 0) {
                    commonItem.style.borderWidthLeft = borderWidthLeft + "pt";
                    commonItem.style.borderStyle = borderStyle;
                }
                if (borderWidthRight != 0) {
                    commonItem.style.borderWidthRight = borderWidthRight + "pt";
                    commonItem.style.borderStyle = borderStyle;
                }
                if (borderWidthTop != 0) {
                    commonItem.style.borderWidthTop = borderWidthTop + "pt";
                    commonItem.style.borderStyle = borderStyle;
                }
                if (borderWidthBottom != 0) {
                    commonItem.style.borderWidthBottom = borderWidthBottom + "pt";
                    commonItem.style.borderStyle = borderStyle;
                }
            }
            var backgroundColor = layoutItem.getAttribute("Background_Color");
            if (backgroundColor != null) {
                backgroundColor = backgroundColor.replace(" ", "");
                if (backgroundColor == ExpressionConstant)
                    backgroundColor = "";
                if (backgroundColor != "")
                    commonItem.style.backgroundColor = backgroundColor;
            }
        }

        if (rectHeight < top + height) {
            rectHeight = top + height;
            if (currRect != null) {
                if (currRect.style.height < rectHeight + uom) {
                    currRect.style.height = rectHeight + uom;
                }
            }
        }
        if (rectWidth < left + width) {
            rectWidth = left + width;
            if (currRect != null)
                if (currRect.sectionType != "Body")
                    if (currRect.style.width < rectWidth + uom)
                        currRect.style.width = rectWidth + uom;
        }

        if (groupHeight.value < top + height)
            groupHeight.value = top + height;

        prevTop = top;
        prevHeight = height;
        prevType = type;
        prevSectionType = sectionType;
        if (sectionType == "Report Header" || sectionType == "Report Footer")
            prevHFSectionType = sectionType;
        if (!concat)
            previousCommonItem = commonItem;

        if (concat && (previousCommonItem != null))
            previousCommonItem.dataSource += " & " + source;

        if (layoutItem.getAttribute("Highlight") == "Yes")
        {
            HighlightControl(layoutItem.getAttribute("Entry_No_"));
        }

        if (commonItem != null) {
            commonItem.dataSource = source;
            commonItem.onmouseenter = OnItemMouseEnter;
            commonItem.onmouseleave = OnItemMouseLeave;
        }
    }

    return layoutItem;
}

function StartDebugger() {
    debugger;
}

function OnItemMouseEnter() {
    HighlightControl(this.id);
    Microsoft.Dynamics.NAV.InvokeExtensibilityMethod("ControlHighlighted", [this.id]);
}

function HighlightControl(layoutEntryNo) {
    var control = $("#" + layoutEntryNo)[0];
    $(".commonItemHover").removeClass("commonItemHover");
    if (control.classList.contains("commonItem"))
        control.classList.add("commonItemHover");

    statusBar.style.visibility = "visible";
    if (!debug)
        logo.src = Microsoft.Dynamics.NAV.GetImageResource("Logo-blue.jpg");
    else
        logo.src = "Image/Logo-blue.jpg";

    while (statusBar.firstChild) {
        statusBar.removeChild(statusBar.firstChild);
    }

    var commonDiv = statusBar.appendChild(document.createElement("div"));
    var labelSpan = commonDiv.appendChild(document.createElement("span"));
    labelSpan.style.float = "left";
    labelSpan.style.width = "60px";
    var textSpan = commonDiv.appendChild(document.createElement("span"));
    textSpan.style.float = "left";

    var newLine = labelSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text("Source: ");
    var source = control.dataSource;
    if (source == "")
        source = "-";
    var newLine = textSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text(source);

    var newLine = labelSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text("Width: ");
    var newLine = textSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text(control.style.width);

    var newLine = labelSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text("Height: ");
    var newLine = textSpan.appendChild(document.createElement("div"));
    $(newLine.appendChild(document.createElement("span"))).text(control.style.height);
}

function OnItemMouseLeave() {
    this.classList.remove("commonItemHover");
    statusBar.style.visibility = "hidden";
    if (!debug)
        logo.src = Microsoft.Dynamics.NAV.GetImageResource("Logo-white.png");
    else
        logo.src = "Image/Logo-white.png";
}